Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.map
Class ReferenceMap

    java.lang.Object
      java.util.AbstractMap
          org.apache.commons.collections.map.AbstractHashedMap
              org.apache.commons.collections.map.AbstractReferenceMap
                  org.apache.commons.collections.map.ReferenceMap

All Implemented Interfaces:
  java.io.Serializable, java.util.Map, IterableMap

    public class ReferenceMap

extends AbstractReferenceMap
implements java.io.Serializable

A `Map` implementation that allows mappings to be removed by the garbage collector.

When you construct a `ReferenceMap`, you can specify what kind of references are used to store the map's keys and values. If non-hard references are used, then the garbage collector can remove mappings if a key or value becomes unreachable, or if the JVM's memory is running low. For information on how the different reference types behave, see `Reference`.

Different types of references can be specified for keys and values. The keys can be configured to be weak but the values hard, in which case this class will behave like a `WeakHashMap`. However, you can also specify hard keys and weak values, or any other combination. The default constructor uses hard keys and soft values, providing a memory-sensitive cache.

This map is similar to `ReferenceIdentityMap`. It differs in that keys and values in this class are compared using `equals()`.

This `Map` implementation does not allow null elements. Attempting to add a null key or value to the map will raise a `NullPointerException`.

This implementation is not synchronized. You can use `Collections.synchronizedMap(java.util.Map)` to provide synchronized access to a `ReferenceMap`. Remember that synchronization will not stop the garbage collecter removing entries.

All the available iterators can be reset back to the start by casting to `ResettableIterator` and calling `reset()`.

Note that ReferenceMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(java.util.Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

NOTE: As from Commons Collections 3.1 this map extends `AbstractReferenceMap` (previously it extended AbstractMap). As a result, the implementation is now extensible and provides a `MapIterator`.

Since:
  Commons Collections 3.0 (previously in main package v2.1)
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Paul Jack, Stephen Colebourne
See Also:
  `Reference`, Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.commons.collections.map.AbstractReferenceMap
`AbstractReferenceMap.ReferenceEntry`

Nested classes/interfaces inherited from class org.apache.commons.collections.map.AbstractHashedMap
`AbstractHashedMap.EntrySet, AbstractHashedMap.EntrySetIterator, AbstractHashedMap.HashEntry, AbstractHashedMap.HashIterator, AbstractHashedMap.HashMapIterator, AbstractHashedMap.KeySet, AbstractHashedMap.KeySetIterator, AbstractHashedMap.Values, AbstractHashedMap.ValuesIterator`

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractReferenceMap
`HARD, keyType, purgeValues, SOFT, valueType, WEAK`

Fields inherited from class org.apache.commons.collections.map.AbstractHashedMap
`data, DEFAULT_CAPACITY, DEFAULT_LOAD_FACTOR, DEFAULT_THRESHOLD, entrySet, GETKEY_INVALID, GETVALUE_INVALID, keySet, loadFactor, MAXIMUM_CAPACITY, modCount, NO_NEXT_ENTRY, NO_PREVIOUS_ENTRY, NULL, REMOVE_INVALID, SETVALUE_INVALID, size, threshold, values`

Constructor Summary
`ReferenceMap()` Constructs a new `ReferenceMap` that will use hard references to keys and soft references to values.
`ReferenceMap(int keyType, int valueType)` Constructs a new `ReferenceMap` that will use the specified types of references.
`ReferenceMap(int keyType, int valueType, boolean purgeValues)` Constructs a new `ReferenceMap` that will use the specified types of references.
`ReferenceMap(int keyType, int valueType, int capacity, float loadFactor)` Constructs a new `ReferenceMap` with the specified reference types, load factor and initial capacity.
`ReferenceMap(int keyType, int valueType, int capacity, float loadFactor, boolean purgeValues)` Constructs a new `ReferenceMap` with the specified reference types, load factor and initial capacity.

Method Summary

Methods inherited from class org.apache.commons.collections.map.AbstractReferenceMap
`clear, containsKey, containsValue, createEntry, createEntrySetIterator, createKeySetIterator, createValuesIterator, doReadObject, doWriteObject, entrySet, get, getEntry, hashEntry, init, isEmpty, isEqualKey, keySet, mapIterator, purge, purge, purgeBeforeRead, purgeBeforeWrite, put, remove, size, values`

Methods inherited from class org.apache.commons.collections.map.AbstractHashedMap
`addEntry, addMapping, calculateNewCapacity, calculateThreshold, checkCapacity, clone, convertKey, destroyEntry, ensureCapacity, entryHashCode, entryKey, entryNext, entryValue, equals, hash, hashCode, hashIndex, isEqualValue, putAll, removeEntry, removeMapping, reuseEntry, toString, updateEntry`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ReferenceMap

    public ReferenceMap()

  Constructs a new `ReferenceMap` that will use hard references to keys and soft references to values.

### ReferenceMap

    public ReferenceMap(int keyType,
                        int valueType)

  Constructs a new `ReferenceMap` that will use the specified types of references.

  Parameters:
    `keyType` - the type of reference to use for keys; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `valueType` - the type of reference to use for values; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`

### ReferenceMap

    public ReferenceMap(int keyType,
                        int valueType,
                        boolean purgeValues)

  Constructs a new `ReferenceMap` that will use the specified types of references.

  Parameters:
    `keyType` - the type of reference to use for keys; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `valueType` - the type of reference to use for values; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `purgeValues` - should the value be automatically purged when the key is garbage collected

### ReferenceMap

    public ReferenceMap(int keyType,
                        int valueType,
                        int capacity,
                        float loadFactor)

  Constructs a new `ReferenceMap` with the specified reference types, load factor and initial capacity.

  Parameters:
    `keyType` - the type of reference to use for keys; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `valueType` - the type of reference to use for values; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `capacity` - the initial capacity for the map
    `loadFactor` - the load factor for the map

### ReferenceMap

    public ReferenceMap(int keyType,
                        int valueType,
                        int capacity,
                        float loadFactor,
                        boolean purgeValues)

  Constructs a new `ReferenceMap` with the specified reference types, load factor and initial capacity.

  Parameters:
    `keyType` - the type of reference to use for keys; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `valueType` - the type of reference to use for values; must be `AbstractReferenceMap.HARD`, `AbstractReferenceMap.SOFT`, `AbstractReferenceMap.WEAK`
    `capacity` - the initial capacity for the map
    `loadFactor` - the load factor for the map
    `purgeValues` - should the value be automatically purged when the key is garbage collected

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.